export class SafariDriver extends BaseDriver<any, import("@appium/types").StringRecord, import("@appium/types").StringRecord, import("@appium/types").DefaultCreateSessionResult<any>, void, import("@appium/types").StringRecord> {
    static newMethodMap: {
        readonly '/session/:sessionId/appium/start_recording_screen': {
            readonly POST: {
                readonly command: "startRecordingScreen";
                readonly payloadParams: {
                    readonly optional: readonly ["options"];
                };
            };
        };
        readonly '/session/:sessionId/appium/stop_recording_screen': {
            readonly POST: {
                readonly command: "stopRecordingScreen";
                readonly payloadParams: {
                    readonly optional: readonly ["options"];
                };
            };
        };
    };
    constructor(opts?: {});
    /** @type {boolean} */
    isProxyActive: boolean;
    /** @type {SafariDriverServer} */
    safari: SafariDriverServer;
    desiredCapConstraints: {
        browserName: {
            isString: boolean;
        };
        browserVersion: {
            isString: boolean;
        };
        acceptInsecureCerts: {
            isBoolean: boolean;
        };
        'safari:platformVersion': {
            isString: boolean;
        };
        'safari:platformBuildVersion': {
            isString: boolean;
        };
        'safari:useSimulator': {
            isBoolean: boolean;
        };
        'safari:deviceType': {
            isString: boolean;
        };
        'safari:deviceName': {
            isString: boolean;
        };
        'safari:deviceUDID': {
            isString: boolean;
        };
        'safari:automaticInspection': {
            isBoolean: boolean;
        };
        'safari:automaticProfiling': {
            isBoolean: boolean;
        };
        'webkit:WebRTC': {
            isObject: boolean;
        };
    };
    resetState(): void;
    proxyReqRes: any;
    _screenRecorder: any;
    proxyActive(): boolean;
    getProxyAvoidList(): import("@appium/types").RouteMatcher[];
    canProxy(): boolean;
    createSession(...args: any[]): Promise<(string | import("@appium/types").DriverCaps<any>)[]>;
    deleteSession(): Promise<void>;
    deleteCookies: typeof cookieCommands.deleteCookies;
    findElOrEls: typeof findCommands.findElOrEls;
    startRecordingScreen: typeof recordScreenCommands.startRecordingScreen;
    stopRecordingScreen: typeof recordScreenCommands.stopRecordingScreen;
}
export default SafariDriver;
import { BaseDriver } from 'appium/driver';
import { SafariDriverServer } from './safari';
import * as cookieCommands from './commands/cookies';
import * as findCommands from './commands/find';
import * as recordScreenCommands from './commands/record-screen';
//# sourceMappingURL=driver.d.ts.map