"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.formatCapsForServer = formatCapsForServer;
const driver_1 = require("appium/driver");
const lodash_1 = __importDefault(require("lodash"));
const SAFARI_CAP_PREFIXES = ['safari:', 'webkit:'];
function formatCapsForServer(caps) {
    const result = {
        browserName: 'Safari',
        browserVersion: caps.browserVersion,
        platformName: caps.platformName || 'iOS',
    };
    for (const [name, value] of lodash_1.default.toPairs(caps)) {
        if (SAFARI_CAP_PREFIXES.some((prefix) => name.startsWith(prefix))) {
            result[name] = value;
            // @ts-ignore This check is OK
        }
        else if (!lodash_1.default.has(result, name) && driver_1.STANDARD_CAPS.has(name)) {
            result[name] = value;
        }
    }
    return result;
}
//# sourceMappingURL=utils.js.map